---
content_title: Development Environment
---

There are several ways to configure a `nodeos` environment for development and testing. Which option to use largely depends on what the project goals are. Some practical options are provided below.

## Local Single-Node Testnet

This is the go-to option for smart contract developers, aspiring Block Producers or Non-Producing Node operators. It has the most simple configuration with the least number of requirements.

* [Configure Nodeos as a Local Single-node Testnet](00_local-single-node-testnet.md) 

## Local Single-Node Testnet With Consensus Protocol

This is the go-to option for smart contract developers, aspiring Block Producers or Non-Producing Node operators. It has the most simple configuration with the least number of requirements to setup a local single-node testnet with consensus protocol enabled.

* [Configure Nodeos as a Local Single-node Testnet with Consensus Protocol](10_local-single-node-testnet-consensus.md)

## Local Multi-Node Testnet

While this option can technically be used for smart contract development, it may be overkill. This is most beneficial for those who are working on aspects of core development, such as benchmarking, optimization and experimentation. It's also a good option for hands-on learning and concept proofing.

* [Configure Nodeos as a Local Two-Node Testnet](20_local-multi-node-testnet.md)
* [Configure Nodeos as a Local 21-Node Testnet](https://developers.eos.io/welcome/latest/tutorials/bios-boot-sequence)

## Official Testnet

The official testnet is available for testing EOSIO dApps and smart contracts:

* [testnet.eos.io](https://testnet.eos.io/)

## Third-Party Testnets

The following third-party testnets are available for testing EOSIO dApps and smart contracts:

* Jungle Testnet [monitor](https://monitor.jungletestnet.io/), [website](https://jungletestnet.io/)
* [CryptoKylin Testnet](https://www.cryptokylin.io/)
* [Telos Testnet](https://mon-test.telosfoundation.io/)
