## Description

Retrieves various items and information from the blockchain

## Subcommands
- [info](info.md) - Get current blockchain information
- [block](block.md) - Retrieve a full block from the blockchain
- [account](account.md) - Retrieve an account from the blockchain
- [code](code.md) - Retrieve the code and ABI for an account
- [abi](abi.md) - Retrieve the ABI for an account
- [table](table.md) - Retrieve the contents of a database table
- [kv_table](kv_table.md) - Retrieve the contents of a database kv_table
- [scope](scope.md) - Retrieve a list of scopes and tables owned by a contract
- [currency](currency.md) - Retrieve information related to standard currencies
- [accounts](accounts.md) - Retrieve accounts associated with a public key
- [servants](servants.md) - Retrieve accounts which are servants of a given account
- [transaction](transaction.md) - Retrieve a transaction from the blockchain
- [actions](actions.md) - Retrieve all actions with specific account name referenced in authorization or receiver
- [schedule](schedule.md) - Retrieve the producer schedule
- [transaction_id](transaction_id.md) - Get transaction id given transaction object
